SystemOrganization addCategory: #'Magma research-MagmaCollections'!
SystemOrganization addCategory: #'Magma research-private'!

!MagmaCollection methodsFor: '*magma research' stamp: 'brp 4/9/2006 13:31'!
segmentAndBitmapFromExpression: aMaExpression startingAt: indexInteger pageSize: anInteger using: aMaReadStrategy

	^ self isNewCollection
		ifTrue:
			[ changes
				localSegmentAndBitmapFromExpression: aMaExpression ]
		ifFalse: 
			[ | segmentAndBitmap |
			segmentAndBitmap :=
				session
					upTo: anInteger
					objectsIn: self
					fromExpression: aMaExpression
					using: aMaReadStrategy.
			changes
				mergeChangesInto: segmentAndBitmap first
				fromExpression: aMaExpression.
			segmentAndBitmap ]! !

!MagmaCollection methodsFor: '*magma research' stamp: 'brp 4/9/2006 15:01'!
segmentFromBitmap: aMaBitmap startingAt: indexInteger pageSize: anInteger using: aMaReadStrategy

	^ self isNewCollection
		ifTrue:
			[ changes
				localSegmentFromBitmap: aMaBitmap ]
		ifFalse: 
			[ | segment |
			segment :=
				session
					upTo: anInteger
					objectsIn: self
					fromBitmap: aMaBitmap
					startingAt: indexInteger 
					using: aMaReadStrategy.
			changes
				mergeChangesInto: segment
				fromBitmap: aMaBitmap.
			segment ]
! !

!MagmaCollection methodsFor: '*magma research' stamp: 'brp 4/9/2006 22:51'!
where: whereBlock

	^ self where: whereBlock orderBy: [ :each ]


		! !

!MagmaCollection methodsFor: '*magma research' stamp: 'brp 4/9/2006 23:08'!
where: whereBlock orderBy: orderBlock

	| reader |
	reader := MagmaExpressionReader new 
		collection: self; 
		readStrategy: (session ifNotNil: [ session resetReadStrategy ]);
		yourself.

	whereBlock value: reader.
	reader order: OrderedCollection new.	"see MagmaExpressionReader>>#doesNotUnderstand:"
	orderBlock value: reader.

	^ reader normalize


		! !

MaObject subclass: #MaBitmapIndex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma research-private'!

!MaBitmapIndex methodsFor: 'as yet unclassified' stamp: 'brp 4/9/2006 19:54'!
andOid: anOidInteger with: aMaBitmapIndex 

	self subclassResponsibility! !

!MaBitmapIndex methodsFor: 'as yet unclassified' stamp: 'brp 4/9/2006 19:54'!
orOid: anOidInteger with: aMaBitmapIndex 

	self subclassResponsibility! !

!MaBitmapIndex methodsFor: 'as yet unclassified' stamp: 'brp 4/9/2006 13:37'!
size

	self subclassResponsibility! !

!MaBitmapIndex methodsFor: 'as yet unclassified' stamp: 'brp 4/9/2006 20:16'!
upTo: countInteger valuesStartingAt: index
	"Answer the specified number of values starting at logical-position index"

	self subclassResponsibility ! !

MaBitmapIndex subclass: #MaSimpleBitmapIndex
	instanceVariableNames: 'oids'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma research-private'!

!MaSimpleBitmapIndex methodsFor: 'as yet unclassified' stamp: 'brp 4/9/2006 20:46'!
addOid: anOidInteger

	(self oids includes: anOidInteger) ifFalse: [ self oids add: anOidInteger ]! !

!MaSimpleBitmapIndex methodsFor: 'as yet unclassified' stamp: 'brp 4/9/2006 20:47'!
andOid: anOidInteger with: aMaBitmapIndex 

	(aMaBitmapIndex oids includes: anOidInteger)
		ifTrue: [ self addOid: anOidInteger ]

! !

!MaSimpleBitmapIndex methodsFor: 'as yet unclassified' stamp: 'brp 4/9/2006 13:38'!
oids

	^ oids ifNil: [ oids := OrderedCollection new ]! !

!MaSimpleBitmapIndex methodsFor: 'as yet unclassified' stamp: 'brp 4/9/2006 20:07'!
oids: anOrderedCollection

	oids := anOrderedCollection
! !

!MaSimpleBitmapIndex methodsFor: 'as yet unclassified' stamp: 'brp 4/9/2006 20:47'!
orOid: anOidInteger with: aMaBitmapIndex 

	self oids: aMaBitmapIndex oids.
	self addOid: anOidInteger! !

!MaSimpleBitmapIndex methodsFor: 'as yet unclassified' stamp: 'brp 4/9/2006 20:25'!
size

	^ self oids size! !

!MaSimpleBitmapIndex methodsFor: 'as yet unclassified' stamp: 'brp 4/9/2006 20:37'!
upTo: countInteger valuesStartingAt: index

	| count |
	count := countInteger min: (self oids size - index + 1).
	^ self oids copyFrom: index to: (index + count - 1).

! !

MaObject subclass: #MagmaExpressionReader
	instanceVariableNames: 'collection expression order pageSize segment readStrategy bitmap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma research-MagmaCollections'!

!MagmaExpressionReader methodsFor: 'enumerating' stamp: 'brp 4/9/2006 20:30'!
abortDo: aBlock

	self maMarked: 'dup'.
	self isNewCollection ifTrue: [ self errorNotPersistent ].
	self
		slowlyDo: aBlock
		pageBoundariesDo: [ self session abort ]! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/9/2006 22:18'!
anyOne

	self maMarked: 'dup'.
	^ self isLoaded 
		ifTrue: [ segment objects anyOne ]
		ifFalse: [ self at: 1 ]! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/9/2006 22:18'!
at: anInteger

	self maMarked: 'dup'.
	^ self
		at: anInteger
		ifOutOfBounds: [ self error: 'out of bounds' ]! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/9/2006 22:20'!
at: anInteger ifOutOfBounds: aBlock

	self maMarked: 'dup'.
	^ self
		primAt: anInteger
		ifOutOfBounds: aBlock! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/6/2006 11:09'!
collection

	^ collection! !

!MagmaExpressionReader methodsFor: 'initialize-release' stamp: 'brp 4/6/2006 11:09'!
collection: aMagmaCollection

	collection := aMagmaCollection! !

!MagmaExpressionReader methodsFor: 'expressions' stamp: 'brp 4/9/2006 23:09'!
doesNotUnderstand: aMessage

	| clause |
	clause := MaClause new
				reader: self;
				index: (collection indexNamed: aMessage selector);
				yourself.

	self expression 
		ifNil: [ self expression: clause ]
		ifNotNil: 
			[ "set from nil in MagmaCollection>>where:order:" 
			(self order notNil and: [self order isEmpty])
				ifTrue: [ self order add: clause ] ].

	^ clause
! !

!MagmaExpressionReader methodsFor: 'enumerating' stamp: 'brp 4/9/2006 20:29'!
do: oneArgBlock

	self maMarked: 'dup'.
	self isNewCollection 
		ifTrue: [ self slowlyDo: oneArgBlock pageBoundariesDo: [] ]
		ifFalse: [ self abortDo: oneArgBlock ]! !

!MagmaExpressionReader methodsFor: 'enumerating' stamp: 'brp 4/9/2006 20:30'!
errorNotPersistent

	self maMarked: 'dup'.
	MagmaUserError signal: 'Not supported for non-persistent collections.'
! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/6/2006 12:12'!
expression

	^ expression! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/6/2006 12:12'!
expression: aTerm

	expression := aTerm
! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/9/2006 22:21'!
first

	self maMarked: 'dup'.
	^ self at: 1! !

!MagmaExpressionReader methodsFor: 'testing' stamp: 'brp 4/9/2006 22:17'!
ifEmpty: emptyBlock ifNotEmptyDo: notEmptyBlock

	self maMarked: 'dup'.
	^ self isEmpty ifTrue: emptyBlock ifFalse: [notEmptyBlock value: self]! !

!MagmaExpressionReader methodsFor: 'testing' stamp: 'brp 4/9/2006 22:17'!
ifEmpty: emptyBlock ifNotEmpty: notEmptyBlock

	self maMarked: 'dup'.
	^ self isEmpty ifTrue: emptyBlock ifFalse: [notEmptyBlock valueWithPossibleArgument: self]! !

!MagmaExpressionReader methodsFor: 'testing' stamp: 'brp 4/9/2006 22:16'!
ifNotEmptyDo: aBlock

	self maMarked: 'dup'.
	^ self isEmpty ifFalse: [aBlock value: self].
! !

!MagmaExpressionReader methodsFor: 'testing' stamp: 'brp 4/9/2006 22:16'!
ifNotEmptyDo: notEmptyBlock ifEmpty: emptyBlock

	self maMarked: 'dup'.
	^ self isEmpty ifFalse: [notEmptyBlock value: self] ifTrue: emptyBlock! !

!MagmaExpressionReader methodsFor: 'testing' stamp: 'brp 4/9/2006 22:16'!
ifNotEmpty: aBlock

	self maMarked: 'dup'.
	^ self isEmpty ifFalse: [aBlock valueWithPossibleArgument: self].
! !

!MagmaExpressionReader methodsFor: 'testing' stamp: 'brp 4/9/2006 22:15'!
ifNotEmpty: notEmptyBlock ifEmpty: emptyBlock

	self maMarked: 'dup'.
	^ self isEmpty ifFalse: [notEmptyBlock valueWithPossibleArgument: self] ifTrue: emptyBlock! !

!MagmaExpressionReader methodsFor: 'initialize-release' stamp: 'brp 4/6/2006 11:22'!
initialize

	super initialize.
	self pageSize: 125.
! !

!MagmaExpressionReader methodsFor: 'testing' stamp: 'brp 4/9/2006 22:14'!
isEmpty

	self maMarked: 'dup'.
	^ self size = 0
! !

!MagmaExpressionReader methodsFor: 'private' stamp: 'brp 4/9/2006 12:52'!
isLoaded

	self maMarked: 'dup'.
	^ segment notNil! !

!MagmaExpressionReader methodsFor: 'testing' stamp: 'brp 4/9/2006 20:29'!
isNewCollection

	self maMarked: 'dup'.
	^ collection isNewCollection! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/9/2006 22:21'!
last

	self maMarked: 'dup'.
	^ self at: self size! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/9/2006 12:51'!
lastKnownSize

	self maMarked: 'dup'.
	self isLoaded ifFalse:
		[ self
			loadFromIndex: 1
			pageSize: 2 "small, since they're only asking for the size." ].
	^ segment lastKnownSize! !

!MagmaExpressionReader methodsFor: 'private' stamp: 'brp 4/9/2006 14:51'!
loadFromIndex: indexInteger pageSize: pageSizeInteger

	| numberOfUncommitted pageStartIndex expandedPageSize |
	self maMarked: 'dup'.

	numberOfUncommitted := self numberOfUncommittedInRange.
	pageStartIndex := indexInteger - numberOfUncommitted max: 1.
	expandedPageSize := pageSizeInteger max: 
							(indexInteger - pageStartIndex) + numberOfUncommitted + 1.

	self segmentFromIndex: pageStartIndex pageSize: expandedPageSize.
	self stronglyReferencePage
! !

!MagmaExpressionReader methodsFor: 'expressions' stamp: 'brp 4/9/2006 23:06'!
normalize

	^ self expression isClause
		ifTrue: 
			[ MagmaCollectionReader
				collection: self collection
				index: self expression index
				lowKey: self expression lowKey
				highKey: self expression highKey
				readStrategy: self readStrategy ]
		ifFalse: 
			[ self expression normalize.
			self order: self order asArray.
			self ]! !

!MagmaExpressionReader methodsFor: 'testing' stamp: 'brp 4/9/2006 22:14'!
notEmpty

	self maMarked: 'dup'.
	^ self isEmpty not
! !

!MagmaExpressionReader methodsFor: 'private' stamp: 'brp 4/9/2006 13:06'!
numberOfUncommittedInRange

	self maMarked: 'dup'.
	^ 0! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/9/2006 23:00'!
order

	^ order! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/9/2006 23:01'!
order: anOrderedCollection 

	order := anOrderedCollection! !

!MagmaExpressionReader methodsFor: 'page' stamp: 'brp 4/6/2006 11:21'!
pageSize
	"The number of object retrieved to memory at a time."

	^ pageSize! !

!MagmaExpressionReader methodsFor: 'page' stamp: 'brp 4/6/2006 11:21'!
pageSize: anInteger 
	"Tell the receiver to retrieve anInteger number of elements at a time when 'scrolling' to a new part of the collection via at:."

	pageSize := anInteger! !

!MagmaExpressionReader methodsFor: 'private' stamp: 'brp 4/9/2006 22:21'!
primAt: indexInteger ifOutOfBounds: aBlock
	"Interrogates the committed and uncommitted contents of the underlying collection."

	self maMarked: 'dup'.
	^ (self isLoaded and: [ segment includesIndex: indexInteger ])
		ifTrue:
			[ segment at: indexInteger ]
		ifFalse:
			[ self
				loadFromIndex: indexInteger
				pageSize: pageSize.
			(segment includesIndex: indexInteger)
				ifTrue: [ segment at: indexInteger ]
				ifFalse: [ aBlock value ] ]
! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/9/2006 13:12'!
readStrategy

	^ readStrategy! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/9/2006 13:12'!
readStrategy: aMaReadStrategy

	readStrategy := aMaReadStrategy! !

!MagmaExpressionReader methodsFor: 'initialize-release' stamp: 'brp 4/6/2006 11:23'!
release

	super release.
	"self removeListener"! !

!MagmaExpressionReader methodsFor: 'private' stamp: 'brp 4/9/2006 14:53'!
segmentFromIndex: indexInteger pageSize: pageSizeInteger

	bitmap 
		ifNil:
			[ | segmentAndBitmap |
			segmentAndBitmap :=
				collection
					segmentAndBitmapFromExpression: expression
					startingAt: indexInteger 
					pageSize: pageSizeInteger
					using: readStrategy.

			segment := segmentAndBitmap first.
			bitmap := segmentAndBitmap last ]
		ifNotNil: 
			[ segment :=
				collection
					segmentFromBitmap: bitmap
					startingAt: indexInteger 
					pageSize: pageSizeInteger
					using: readStrategy ]
! !

!MagmaExpressionReader methodsFor: 'private' stamp: 'brp 4/9/2006 14:05'!
session

	self maMarked: 'dup'.
	^ collection session
! !

!MagmaExpressionReader methodsFor: 'accessing' stamp: 'brp 4/9/2006 12:51'!
size
	"Retrieve the latest-known size from the server, regardless if I'm already loaded."
	self maMarked: 'dup'.
	self isLoaded
		ifTrue:
			[ self
				loadFromIndex: segment startIndex
				pageSize: 2 ].
	^ self lastKnownSize! !

!MagmaExpressionReader methodsFor: 'enumerating' stamp: 'brp 4/9/2006 20:31'!
slowlyDo: oneArgBlock pageBoundariesDo: aBlock
	"Approximately enumerate all elements of the receiver."

	| x done stopwatch seg |
	self maMarked: 'dup'.
	done := false.
	x := 1.
	stopwatch := MaStopwatch new start.
	[ done ]
		whileFalse:
			[ self
				loadFromIndex: x
				pageSize: 100.
			seg := segment. "because segment can be nil'd out in #update:"
			seg objects do:
				[ :each | oneArgBlock value: each.
				stopwatch time > 5 maSeconds
					ifTrue:
						[ MagmaNotification signal: (x-1) printString, ' objects enumerated.'.	
						stopwatch restart ] ].
			x := x + seg actualPageSize.
			done := seg atEnd ]
! !

!MagmaExpressionReader methodsFor: 'private' stamp: 'brp 4/9/2006 13:32'!
stronglyReferencePage

	| session  |
	self maMarked: 'dup'.

	session := self session.
	(session notNil and:
	[ session inTransaction and:
	[ segment notNil ] ]) 
		ifTrue:
			[ session stronglyReference: segment objects ]! !

!MagmaExpressionReader methodsFor: 'enumerating' stamp: 'brp 4/9/2006 22:13'!
withIndexDo: elementAndIndexBlock 

	self maMarked: 'dup'.
	1 to: self size do:
		[ :i |
		elementAndIndexBlock
			value: (self at: i)
			value: i]! !

MaObject subclass: #MaTerm
	instanceVariableNames: 'reader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma research-MagmaCollections'!

MaTerm subclass: #MaClause
	instanceVariableNames: 'index lowKey highKey reversed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma research-MagmaCollections'!

!MaClause methodsFor: 'order' stamp: 'brp 4/9/2006 22:57'!
ascend

	self reverse: false.
! !

!MaClause methodsFor: 'operators' stamp: 'brp 4/9/2006 11:18'!
at: anObject

	lowKey := highKey := index indexHashForIndexObject: anObject! !

!MaClause methodsFor: 'operators' stamp: 'brp 4/9/2006 11:18'!
between: lowObject and: highObject

	self from: lowObject to: highObject
! !

!MaClause methodsFor: 'order' stamp: 'brp 4/9/2006 22:57'!
descend

	self reverse: true! !

!MaClause methodsFor: 'enumerating' stamp: 'brp 4/9/2006 11:46'!
do: aBlock

	aBlock value: self
! !

!MaClause methodsFor: 'operators' stamp: 'brp 4/9/2006 11:18'!
equals: anObject

	self at: anObject! !

!MaClause methodsFor: 'operators' stamp: 'brp 4/9/2006 11:19'!
from: anObject

	lowKey := index indexHashForIndexObject: anObject.
	highKey := index highestPossibleKey ! !

!MaClause methodsFor: 'operators' stamp: 'brp 4/9/2006 11:17'!
from: lowObject to: highObject

	lowKey := index indexHashForIndexObject: lowObject.
	highKey := index indexHashForIndexObject: highObject! !

!MaClause methodsFor: 'operators' stamp: 'brp 4/9/2006 11:21'!
from: lowObject upTo: highObject

	lowKey := index indexHashForIndexObject: lowObject.
	highKey := (index indexHashForIndexObject: highObject) - 1 max: 0.! !

!MaClause methodsFor: 'accessing' stamp: 'brp 4/6/2006 12:10'!
highKey

	^ highKey
! !

!MaClause methodsFor: 'initialize-release' stamp: 'brp 4/6/2006 11:22'!
highKey: anInteger

	highKey := anInteger! !

!MaClause methodsFor: 'accessing' stamp: 'brp 4/6/2006 11:45'!
index

	^ index! !

!MaClause methodsFor: 'initialize-release' stamp: 'brp 4/6/2006 11:22'!
index: aMaIndexDefinition

	index := aMaIndexDefinition
! !

!MaClause methodsFor: 'initialize-release' stamp: 'brp 4/9/2006 22:46'!
initialize

	super initialize.
	reversed := false! !

!MaClause methodsFor: 'testing' stamp: 'brp 4/9/2006 11:51'!
isClause

	^ true! !

!MaClause methodsFor: 'processing' stamp: 'brp 4/9/2006 19:46'!
keysAndOidsDo: aBlock using: aMaCollectionManager

	(aMaCollectionManager indexForAttribute: self index attribute)
		entriesFrom: lowKey
		do: 
			[ :hir :i :level | 
			(hir hasEntryAtByteArrayIndex: i)
				ifTrue: [ aBlock 
					value: (hir keyAtByteArrayIndex: i) 
					value: (hir valueAtByteArrayIndex: i) ] ]
		until:
			[ :hir :i :level |
			"Until we're on an entry that could not possibly hold keyInteger."
			(hir hasEntryAtByteArrayIndex: i)
				and: [ (hir keyAtByteArrayIndex: i) > highKey ] ]

! !

!MaClause methodsFor: 'accessing' stamp: 'brp 4/6/2006 12:09'!
lowKey

	^ lowKey
! !

!MaClause methodsFor: 'initialize-release' stamp: 'brp 4/6/2006 11:23'!
lowKey: anInteger

	lowKey := anInteger! !

!MaClause methodsFor: 'printing' stamp: 'brp 4/9/2006 17:17'!
printOn: aStream

	super printOn: aStream.
	aStream 
		nextPut: $(; 
		nextPutAll: self index attribute; 
		space;
		print: self lowKey;
		nextPut: $:; 
		print: self highKey;
		nextPut: $)

! !

!MaClause methodsFor: 'order' stamp: 'brp 4/9/2006 22:57'!
reverse: aBoolean

	reversed := aBoolean! !

!MaClause methodsFor: 'operators' stamp: 'brp 4/9/2006 11:19'!
to: anObject

	lowKey := 0.
	highKey := index indexHashForIndexObject: anObject.! !

!MaClause methodsFor: 'order' stamp: 'brp 4/9/2006 23:05'!
, aMaClause

	^ self reader order add: aMaClause
! !

MaTerm subclass: #MaExpression
	instanceVariableNames: 'operator terms'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma research-MagmaCollections'!

!MaExpression methodsFor: 'accessing' stamp: 'brp 4/9/2006 11:59'!
addTerm: aMaTerm

	self terms add: aMaTerm! !

!MaExpression methodsFor: 'enumerating' stamp: 'brp 4/9/2006 12:00'!
do: aBlock
	"depth-first traversal"

	self terms do: [ :t | t do: aBlock ].
	aBlock value: self


! !

!MaExpression methodsFor: 'enumerating' stamp: 'brp 4/9/2006 20:04'!
inject: thisValue 
beforeConjunctionDo: beforeAndBlock 
beforeDisjunctionDo: beforeOrBlock
termsDo: aQuaternaryBlock 
afterConjunctionDo: afterAndBlock 
afterDisjunctionDo: afterOrBlock

	| nextValue i |
	nextValue := ( (self operator = #&) ifTrue: [beforeAndBlock] ifFalse: [beforeOrBlock] )
		value: thisValue value: self.

	self terms 
		select: [ :t | t isExpression and: [t operator = #&] ] 
		thenDo: 
			[ :t |  
			nextValue := t 
				inject: nextValue
				beforeConjunctionDo: beforeAndBlock
				beforeDisjunctionDo: beforeOrBlock
				termsDo: aQuaternaryBlock
				afterConjunctionDo: afterAndBlock
				afterDisjunctionDo: afterOrBlock ].

	self terms 
		select: [ :t | t isExpression and: [t operator = #|] ] 
		thenDo: 
			[ :t |  
			nextValue := t 
				inject: nextValue
				beforeConjunctionDo: beforeAndBlock
				beforeDisjunctionDo: beforeOrBlock
				termsDo: aQuaternaryBlock
				afterConjunctionDo: afterAndBlock
				afterDisjunctionDo: afterOrBlock ].

	i := 1.
	self terms 
		select: [ :t | t isClause ]
		thenDo: 
			[ :t | 
			nextValue := aQuaternaryBlock 
				value: nextValue 
				value: self 
				value: t
				value: i.
			i := i + 1 ].

	nextValue := ( (self operator = #&) ifTrue: [afterAndBlock] ifFalse: [afterOrBlock] )
		value: nextValue value: self.

	^ nextValue
! !

!MaExpression methodsFor: 'testing' stamp: 'brp 4/9/2006 11:52'!
isExpression

	^ true! !

!MaExpression methodsFor: 'expressions' stamp: 'brp 4/9/2006 23:11'!
normalize

	super normalize.

	self terms do: [ :t | t normalize ].
	((self terms select: [ :t | t isExpression ]) allSatisfy: [ :t | t operator = self operator ])
		ifTrue: 
			[ | all |
			all := OrderedCollection new.
			self terms do: [ :t  | t isClause ifTrue: [all add: t] ifFalse: [all addAll: t terms] ].
			self terms: all ].
	 self terms: self terms asArray



! !

!MaExpression methodsFor: 'accessing' stamp: 'brp 4/6/2006 12:07'!
operator

	^ operator
! !

!MaExpression methodsFor: 'accessing' stamp: 'brp 4/9/2006 11:22'!
operator: aSymbol

	operator := aSymbol
! !

!MaExpression methodsFor: 'printing' stamp: 'brp 4/9/2006 11:22'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: $(; nextPutAll: self operator; nextPut: $)

! !

!MaExpression methodsFor: 'accessing' stamp: 'brp 4/9/2006 11:58'!
terms

	^ terms ifNil: [ terms := OrderedCollection new ]! !

!MaExpression methodsFor: 'accessing' stamp: 'brp 4/9/2006 11:59'!
terms: anOrderedCollection

	terms := anOrderedCollection
! !

!MaTerm methodsFor: 'expressions' stamp: 'brp 4/9/2006 12:01'!
connect: aMaTerm operator: aSymbol

	| expression |
	expression := MaExpression new
					reader: self reader;
					operator: aSymbol;
					addTerm: self;
					addTerm: aMaTerm
					yourself.

	self reader expression: expression.
	^ expression ! !

!MaTerm methodsFor: 'enumerating' stamp: 'brp 4/9/2006 11:51'!
do: aBlock

	self subclassResponsibility ! !

!MaTerm methodsFor: 'testing' stamp: 'brp 4/9/2006 11:51'!
isClause

	^ false! !

!MaTerm methodsFor: 'testing' stamp: 'brp 4/9/2006 11:51'!
isExpression

	^ false! !

!MaTerm methodsFor: 'expressions' stamp: 'brp 4/9/2006 12:19'!
normalize

	self reader: nil! !

!MaTerm methodsFor: 'accessing' stamp: 'brp 4/9/2006 11:30'!
reader

	^ reader! !

!MaTerm methodsFor: 'initialize-release' stamp: 'brp 4/9/2006 11:31'!
reader: aMagmaExpressionReader 

	reader := aMagmaExpressionReader ! !

!MaTerm methodsFor: 'expressions' stamp: 'brp 4/9/2006 11:36'!
& aMaTerm

	^ self connect: aMaTerm operator: #&! !

!MaTerm methodsFor: 'expressions' stamp: 'brp 4/9/2006 11:36'!
| aMaTerm

	^ self connect: aMaTerm operator: #|! !

!MaObjectRepository methodsFor: '*magma research' stamp: 'brp 4/9/2006 20:48'!
bitmapIndexFor: aMaExpression inLargeCollection: collectionOid forSession: sessionId

	| manager |
	manager := self collectionManagerFor: collectionOid.

	^ aMaExpression 
		inject: MaSimpleBitmapIndex new
		beforeConjunctionDo: [ :bm :t | bm ]
		beforeDisjunctionDo: [ :bm :t | bm ]
		termsDo: 
			[ :bm :parent :t :i | | oids |
			oids := MaSimpleBitmapIndex new.
			( (parent operator = #&) and: [i > 1] )
				ifTrue: 
					[ t keysAndOidsDo: [ :k :o | oids andOid: o with: bm ] using: manager ]
				ifFalse:
					[ t keysAndOidsDo: [ :k :o | oids orOid: o with: bm ] using: manager ].
			oids ]
		afterConjunctionDo: [ :bm :t | bm ]
		afterDisjunctionDo: [ :bm :t | bm ]
! !

!MaObjectRepository methodsFor: '*magma research' stamp: 'brp 4/9/2006 13:57'!
upTo: anInteger oidsFromBitmap: aMaBitmapIndex startingAt: indexInteger inLargeCollection: collectionOid using: aMaReadStrategy forSession: sessionId

	| segmentResult |
	segmentResult := (self collectionManagerFor: collectionOid)
		upTo: anInteger
		inSegmentFromBitmap: aMaBitmapIndex
		startingAt: indexInteger.

	segmentResult
		objects:
			(segmentResult objects collect:
				[ :each | 
				self
					byteArrayAt: each
					using:
						(self 
							ensureReadStrategy: aMaReadStrategy
							forSession: sessionId) ]).
	self
		renewServerNotificationsIn: segmentResult
		for: sessionId.
	^ segmentResult! !

!MagmaCollectionChanges methodsFor: '*magma research' stamp: 'brp 4/9/2006 14:02'!
localSegmentAndBitmapFromExpression: aMaExpression

	self maMarked: 'dev'
! !

!MagmaCollectionChanges methodsFor: '*magma research' stamp: 'brp 4/9/2006 14:54'!
localSegmentFromBitmap: aMaBitmap

	self maMarked: 'dev'
! !

!MagmaCollectionChanges methodsFor: '*magma research' stamp: 'brp 4/9/2006 15:01'!
mergeChangesInto: aSegment fromBitmap: aMaBitmap

	self maMarked: 'dev'! !

!MagmaCollectionChanges methodsFor: '*magma research' stamp: 'brp 4/9/2006 14:02'!
mergeChangesInto: aSegment fromExpression: aMaExpression

	self maMarked: 'dev'! !

!MagmaSession methodsFor: '*magma research' stamp: 'brp 4/9/2006 15:00'!
upTo: anInteger objectsIn: aMagmaCollection fromBitmap: aMaBitmap startingAt: indexInteger using: aMaReadStrategy

	| segment |
	segment :=
		self submit: (
			MaSegmentFromBitmapRequest new
				quantity: anInteger;
				collectionOid: (self oidFor: aMagmaCollection);
				bitmap: aMaBitmap;
				lowIndex: indexInteger;
				readStrategy: aMaReadStrategy ;
				yourself).

	self materializeObjectsIn: segment.
	^ segment
! !

!MagmaSession methodsFor: '*magma research' stamp: 'brp 4/9/2006 13:28'!
upTo: anInteger objectsIn: aMagmaCollection fromExpression: aMaExpression using: aMaReadStrategy

	| segmentAndBitmap |
	segmentAndBitmap :=
		self submit: (
			MaSegmentFromExpressionRequest new
				quantity: anInteger;
				collectionOid: (self oidFor: aMagmaCollection);
				expression: aMaExpression;
				readStrategy: aMaReadStrategy ;
				yourself).
	self materializeObjectsIn: segmentAndBitmap first.
	^ segmentAndBitmap
! !

MaLargeCollectionSegmentRequest subclass: #MaSegmentFromBitmapRequest
	instanceVariableNames: 'bitmap lowIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma research-private'!

!MaSegmentFromBitmapRequest methodsFor: 'building' stamp: 'brp 4/9/2006 14:56'!
bitmap: aMaBitmap

	bitmap := aMaBitmap! !

!MaSegmentFromBitmapRequest methodsFor: 'building' stamp: 'brp 4/9/2006 14:58'!
lowIndex: anInteger

	lowIndex := anInteger
! !

!MaSegmentFromBitmapRequest methodsFor: 'actions' stamp: 'brp 4/9/2006 19:50'!
process

	^ self repository
		upTo: quantity
		oidsFromBitmap: bitmap
		startingAt: lowIndex
		inLargeCollection: collectionOid
		using: readStrategy
		forSession: sessionId.
! !

MaLargeCollectionSegmentRequest subclass: #MaSegmentFromExpressionRequest
	instanceVariableNames: 'expression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma research-private'!

!MaSegmentFromExpressionRequest methodsFor: 'building' stamp: 'brp 4/9/2006 13:27'!
expression: aMaExpression

	expression := aMaExpression
! !

!MaSegmentFromExpressionRequest methodsFor: 'actions' stamp: 'brp 4/9/2006 20:24'!
process
	"Answer the first segment and the bitmap index for this expression."

	| bitmap segment |
	bitmap := self repository
		bitmapIndexFor: expression
		inLargeCollection: collectionOid 
		forSession: sessionId.

	segment := self repository
		upTo: quantity
		oidsFromBitmap: bitmap
		startingAt: 1
		inLargeCollection: collectionOid
		using: readStrategy
		forSession: sessionId.

	^ { segment. bitmap }
! !

!MagmaCollectionManager methodsFor: '*magma research' stamp: 'brp 4/9/2006 20:24'!
upTo: anInteger inSegmentFromBitmap: aMaBitmapIndex startingAt: indexInteger

	| oids |
	oids := aMaBitmapIndex upTo: anInteger valuesStartingAt: indexInteger.

	^ MagmaLargeCollectionSegment new
		lastKnownSize: aMaBitmapIndex size;
		keys: (Array new: oids size);
		objects: oids;
		startIndex: indexInteger;
		yourself
! !
